#!/usr/bin/env python
#coding=utf-8

from math import sqrt

class Point(object):

    def __init__(self, x=0, y=0):
        self.x = x
        self.y = y

    def __str__(self):
        return "point (%.1f, %.1f)" % (self.x, self.y)

    def distance(self, point2):
        """returns Euclidean distance from point point2"""
        return sqrt((self.x - point2.x)**2 + (self.y - point2.y)**2)

if __name__ == "__main__":
    point0 = Point(0,0)
    point1 = Point(2,3)
    print  "distance %s->%s = %f" % (point0, point1,  point1.distance(point0))
