"""
Functions counting the number of lines and characters in a file
"""
import sys

def countlines(name):
    """Returns number of lines in a file 'name'"""
    f = open(name, 'r')
    return len(f.readlines())

def countChars(name):
    """Return number of characters in a file 'name'"""
    f = open(name, 'r')
    return len(f.read())

def test(name):
    """Prints number of lines and characters in a file"""
    print "File:", name
    print "Number of lines:", countlines(name)
    print "Number of characters:", countChars(name)

if __name__ == '__main__':
    #you can pass the filenames as command line arguments
    # command line arguments are available in a list defined in
    # sys module (sys.argv)
    if sys.argv[1:]:
        for name in sys.argv[1:]:
            test(name)
    else:
        print "Usage: python mymode.py filename(s)"  


