import unittest
import sys
import Agents
import testingTools

class ManhattanLunchtimeAgentTest(unittest.TestCase):    
    def test_choose_action(self):

        testagent=Agents.ScoringAgent(0,Agents.ScoringFunctions().nearest_manhattan_food_f)
	
        layout_txt = """%%%%%%%%
                        %     .%
                        %  . ..%
                        %1     %
                        %%%%%%%%
                        """
        lt, game = testingTools.get_mock_game(layout_txt, [testagent])
        game._init_run()
	while True:
	    game._one_game_step()
	    print game.state
	    raw_input()
	
if __name__=="__main__":
    unittest.main()
