"""
This is the main class to create agents
"""

import random
from basic_agents import BasicAgent, BasicAgentFactory

class Group2Agent(BasicAgent):
    def choose_action(self, game_state):
        self.say(random.choice(['Burp', 'Blah', 'Mrmmmf']))
        actions = game_state.getLegalActions(self.index)
        return random.choice(actions)

class Group2Agent_1(BasicAgent):
    def choose_action(self, game_state):
        self.say(random.choice(['agg', 'ra', 'dfgg']))
        actions = game_state.getLegalActions(self.index)
        return random.choice(actions)





class Group2AgentFactory(BasicAgentFactory):
    def get_agents_list(self):
        return [Group2Agent, Group2Agent_1]
