import sys

def pr(game_state, what, *args):
    ret = getattr(game_state, what).__call__(*args)
    print "%s%s:" % (what, args),
    sys.stdout.flush()
    print ret

def du(game_state, what):
    ret = getattr(game_state, what)
    print "%s: %s" % (what, ret)

def dump_state(game_state):
    print game_state
    
    pr(game_state, 'getNumAgents')
    for i in range(game_state.getNumAgents()):
        pr(game_state, 'getAgentPosition', i)
    for i in range(game_state.getNumAgents()):
        pr(game_state, 'getAgentState', i)
    for i in range(game_state.getNumAgents()):
        pr(game_state, 'getLegalActions', i)
    du(game_state, 'teams')
    du(game_state, 'blueTeam')
    du(game_state, 'redTeam')
    du(game_state, 'agentDistances')
    for i in range(game_state.getNumAgents()):
        print "view for", i
        print game_state.makeObservation(i)

    pr(game_state, 'getWalls')

    walls = numpy.array(game_state.getWalls().data)
    for line in walls.T:
        for point in line:
            if point:
                sys.stdout.write('%%')
            else:
                sys.stdout.write('  ')
        print
