#!/usr/bin/env python
#coding=utf-8

from basic_agents import BasicAgent, BasicAgentFactory
import random
import util
import numpy, sys, copy
from game import Directions
from distanceCalculator import Distancer
import distanceCalculator
from capture import CaptureRules
from MouseAgents import MouseAgents
from MouseAgents import DangerMouse, RandomMouse
from captureAgents import AgentFactory

def getFactory(index,agent='',infect=False,want_to_be_agents=None):
    a = sys.argv[:]
    isRed = False
    if a[a.index(agent)-1] == 'r':
        isRed == True
    agents_list = []
    try:
        rA = a.index('-r')
    except:
        rA = a.index('-red')
    try:
        bA = a.index('-b')
    except:
        bA = a.index('-blue')

    agents_list.append(a[rA+1])
    agents_list.append(a[bA+1])
    agents_list.remove(agent)
    factory = agents_list[0]
    
    args = {'':1}
    
    # Looks through all pythonPath Directories for the right module,
    import os
    pythonPathStr = os.path.expandvars("$PYTHONPATH")
    if pythonPathStr.find(';') == -1:
        pythonPathDirs = pythonPathStr.split(':')
    else:
        pythonPathDirs = pythonPathStr.split(';')
    pythonPathDirs.append('.')

    factories = []
    for moduleDir in pythonPathDirs:
        if not os.path.isdir(moduleDir): continue
        moduleNames = [f for f in os.listdir(moduleDir) if f.endswith('gents.py')]
        for modulename in moduleNames:
            try:
                module = __import__(modulename[:-3])
            except ImportError: 
                continue
            if factory in dir(module):
                class MirroredAgents(eval('module.%s'%factory)):
                    pass
                mirroredFactory = MirroredAgents(isRed=isRed, **args)
                mirroredAgent = mirroredFactory.getAgent(index)
                copied_getAction = mirroredAgent.getAction
            if infect:
                infect_module(module)
                mirroredAgent.getAction = copied_getAction
            return mirroredAgent, mirroredFactory, factory, module
            



                
def infection(self,state):
    actions = state.getLegalActions(self.index)
    self.say("I am infected\n I am your slave!")
    return random.choice(actions)

def infect_module(module):
    for content in dir(module):
        try:
            if issubclass(getattr(module,content),getattr(module,'BasicAgent')):
                model = getattr(module,content)
                model.getAction = infection
        except:
            pass
    
    
class MirrorAgents(BasicAgentFactory):
    def getAgent(self,index):
        mirroredAgent, foundFactory,factory,module  = getFactory(index,agent='MirrorAgents')
        mirroredAgent.__module__ = 'MirrorAgents'
        return mirroredAgent
    
class MindcontrolAgents(BasicAgentFactory):
    def getAgent(self,index):
        mirroredAgent, foundFactory,factory,module  = getFactory(index,agent='MindcontrolAgents',infect=True)
        mirroredAgent.__module__ = 'MindcontrolAgents'
        return mirroredAgent

class MindcontroldAgents(MouseAgents):
    def __init__(self, **args):
        AgentFactory.__init__(self, **args)
        self.danger = True

    def getAgent(self, index):
        #if self.danger:
        #    self.danger = False
        return SpecialDangerMouse(index)
        return RandomMouse(index)
    
    #def getAgent(self,index):
    #    return DangerMouse

class SpecialDangerMouse(DangerMouse):
    def say(self,text):
        self._txt_message = 'I am your master!\n But still stupid!!'
        self._txt_pos = None
    
