#!/usr/bin/env python
#coding=utf-8

import sys
import os
import capture
from basic_agents import BasicAgentFactory


class ParallelUniverseAgents(BasicAgentFactory):
    
    def getAgent(self, index):
        #super(ParallelUniverseAgents, self).__init__(**args)
        a = sys.argv[:]
        im_red = False
        if len(a) <= 1:
            raise SubspaceDisasterException
        myind = a.index('ParallelUniverseAgents')
        myopt = a[myind-1]
        if myopt == '-r':
            otheropt = '-b'
        elif myopt == '--red':
            otheropt = '--blue'
        elif myopt == '-b':
            otheropt = '-r'
        elif myopt == '--blue':
            otheropt = '--red'
        else:
            raise SubspaceDisasterException
        a[myind] = 'AllOffenseAgents'
        otherind = a.index(otheropt) + 1
        a[otherind] = 'DrunkAgentFactory'
        os.system('python ' + ' '.join(a))
        sys.exit(0)

class SubspaceDisasterException(Exception):
    def __init__(self, expression, message):
        self.message = """

Warp core breach due to subspace rupture
in verteron converter energy coupling.

Initiating emergency eject procedure.

Formatting disk.
 
"""