# these are code snippits i no longer needed

        # these are our possible states (but i'm not quite sure about state
        # changes)
        # EAT = find food and eat it
        # RUN = run away from enemy
        # SEARCH = look for enemies in our teritory
        # HIT = pursue an enemy
        self.states = ['EAT', 'RUN', 'SEARCH','HIT']
        # this is our current state
        self.current = 'EAT'
        self.paranoia = 3
        # enemy distance to run at
 
        # first check for enemies and run away if needed
        self.check_state_change()
        if self.current is "EAT":
            return self.get_eat_action()
        elif self.current is "RUN":
            return self.get_run_action()

    def check_state_change(self):
        # if we are eating, and enemies turn up, RUN
        if self.current is "EAT" and self.enemy_is_close():
                self.current = "RUN"
        # if we have been running and there are no longer any enemies EAT
        if self.current is "RUN" and not self.enemy_is_close():
                self.current = "EAT"

    def get_run_action(self):
        # FIXME implement this
        return self.get_random_action()

    def add_path(self, path):
        pos = path.end.pos
        if self.paths.has_key(pos):
            self.paths[pos].append(path)
        else:
            self.paths[pos] = [path]

    def shortest_path(self,pos):
        # FIXME this assumes they are sorted, need to check that path sorting
        # works
        return self.paths[pos][0]

    def reverse(self):
        self.actions.reverse()

    def init_lookup_table():
        all_paths(self.nodes.values()[0]) 
        all_paths_backwards(self.nodes)
        sort_all_paths(self.nodes)

    def shortest_distance(self, pos1, pos2):
        return len(self.nodes[pos1].paths[pos2][0])

    def bfs_trackback(self, current, end, node_list, visited=None):
        if visited is None:
            visited = set()
        if current not in node_list:
            print current
            return None
        visited.add(current)
        for (action, neighbour) in self.nodes[current].neighbours:
            if neighbour.pos == end:
                return [action]
            if neighbour.pos not in visited and not neighbour.is_dead_end and\
            neighbour.pos in node_list:
                ret = self.bfs_trackback(neighbour.pos, end, node_list,
                        visited)
                if ret is not None:
                    ret.append(action)
                    return ret

    def dfs(self, current, goal):
        p = self.dfs_rec(self.nodes[current], self.nodes[goal], 100)
        print "number of paths from: ", current, " to: ", goal, " = ",  len(p)
        p.sort()
        p[0].reverse()
        return p[0].actions

    def dfs_rec(self, current, goal, limit, visited=None):
        if visited is None:
            visited = set()
        if limit is 0:
            return []
        else:
            limit -= 1
        visited.add(current.pos)
        paths = []
        copy = False
        for (action, neighbour) in current.neighbours:
            if neighbour == goal:
                return[Path(current, neighbour, [action])]
            if neighbour.pos not in visited and not neighbour.is_dead_end:
                if not copy:
                    pre_paths = self.dfs_rec(neighbour ,goal, limit, visited)
                    copy = True
                else:
                    pre_paths = self.dfs_rec(neighbour ,goal, limit, 
                            visited)
                for p in pre_paths:
                    p.start = current
                    p.actions.append(action)
                    paths.append(p)
        return paths


    def shortest_path(self, pos1, pos2):
        if pos1 == pos2:
            return [Directions.STOP]
        else:
            return self.nodes[pos1].shortest_path(pos2).actions

def all_paths(current, visited=None):
    ''' recursive depth first search (dfs)
        paths are stored in nodes on the way back up '''
    if visited is None:
        visited = set()
    visited.add(current)
    paths = []
    for (action, neighbour) in current.neighbours:
        if neighbour not in visited:
            paths.append(Path(current.pos, neighbour.pos, [action]))
            pre_paths = all_paths(neighbour, visited.copy())
            for p in pre_paths:
                p.start = current.pos
                p.actions.append(action)
                paths.append(p)
        
    # now we have a list of all paths from start to goal and everything in
    # between (hopefully) at least in one direction
    for path in paths:
        c = Path.copy(path)
        # since we are using recursion we append to the list in reverse order
        # for proper action execution of an agent we need to reverse the list
        # here
        c.reverse()
        current.add_path(c)

    return paths

def all_paths_backwards(nodes):
    ''' after dfs, reverse all paths '''
    copy = []
    # extra copy needed, otherwise we add stuff we already added via this method
    for node in nodes.values():
        for paths in node.paths.values():
            for p in paths:
                copy.append(p)

    for p in copy:
        c = Path.copy(p)
        c.backwards()
        nodes[c.start.pos].add_path(c)

def sort_all_paths(nodes):
    ''' sort all path lists in the nodes '''
    for node in nodes.values():
        for paths in node.paths.values():
            print paths
            paths.sort()

    def pre_state_change(self):
        if not self.agent.enemy_is_close(self.agent.paranoia):
            # enemy not close switch back to hungry state with old target
            self.agent.state = HungryState(self.agent, path=self.path)
            return True

class HungryDangerState(HungryState):
    def __init__(self, agent, path=None):
        HungryState.__init__(self, agent, path)
        self.agent.print_debug("entered HungryDangerState")

    def choose_action(self):
        # if there are no 
        # if enemy has not been seen for 3 moves, revert to Hungry state

        # enemy is near change to HungryDangerState, but only if we are a pacman
        # If there are only 2 food left, don't get worried
        if self.agent.enemy_is_close(self.agent.paranoia) and \
            self.agent.is_pacman and len(self.agent.food_list) > 3:
            self.agent.state = HungryDangerState(self.agent,
                    path=self.path)
            return True

       
        # get the shortest path for food that does not contain enemies
        self.path = self.agent.graph.bfs_all(self.agent.position,
                self.agent.food_list, seen=self.agent.ghost_positions())[0]
        #for path in sorted_paths:
        #    if all([pos not in path.positions for pos in
        #        self.agent.enemy_positions()]):
        #        self.path = path
        #        return
        # if we got here there are no paths left


        # select an alternative food source that does not contain the enemy
        # and plot a course
        # FIXME enemy_pos is a list, just pass that as seen list to bfs
        #if any([pos in self.path.positions for pos in enemy_pos]):
        #    # get all paths to food
        #    sorted_paths = self.agent.graph.bfs_all(self.agent.position,
        #            self.agent.food_list)
        #    for path in sorted_paths:
        #        if all([pos not in path.positions for pos in enemy_pos]):
        #            # found a path that does not contain the current enemy
        #            # position 
        #            self.path = path
        #            return
        #    # all shortest paths to all food contain enemies
        #    # try to find alternative route
        #    sorted_paths = self.agent.graph.bfs_all(self.agent.position,
        #            self.agent.food_list, seen=enemy_pos)

        #    print "FAIL"
        #    return Directions.STOP
        #else:
        #    self.path = closest_target(self.agent.graph,
        #            self.agent.position,
        #            self.agent.food_list)


#        if self.agent.position is self.path.end or \
#                self.path.end not in self.agent.food_list or \
#                not self.agent.game_state.hasFood(self.path.end[0],
#                        self.path.end[1]) or \
#                len(self.path) is 0:
#            #FIXME don't eat enemy food
#            self.select_new_path()
        for ninja in self.ninjas:
            print ninja.index
            print 'state' in dir(ninja)
            if 'state' in dir(ninja):
                print ninja.state.state_name is 'HungryState'

        print "paths:", len(paths)
        #now chuck out all paths that would take us closer to enemy
        print "TRYING TO CHUCK OUT PATHS"
        for p in paths:
            print "path positions: ", p.positions
        for p in paths:
            print "REAL LOOP:", p.positions
            if p.gets_closer_to(self.agent.ghost_positions(), self.agent.graph):
                print "removing path"
                # okay the remove call fucks the iterator
                paths.remove(p)
        print "pathsleft:", len(paths)
        print "possible paths"
        for p in paths:
            print "path positions: ", p.positions
        #paths.remove(paths[0])

        #if self.path is not None and self.agent.ghost_in_path(self.path):
        #    self.print_debug("enemy in path")
        #    self.select_flee_path()
         #if self.path is None:
        #    # double check that there is no flee-path
        #    self.select_flee_path()
        #    if self.path is None:
        #        return Directions.STOP
        #if self.agent.detect_cycles():
        #    self.print_debug("cycles detected switching to choji")
        #    self.agent.set_Choji()
        #    self.agent.reset_state()
        #    return True


