import random
import exceptions

class FactorialException(exceptions.Exception):
    pass

def get_data(_len = 100):
    return [random.randint(1, 70) for _ in range(_len)]

def fact(n):
    if n < 1:
        raise FactorialException("What were you thinking?")
    prod = n
    for i in range(1, n):
        prod *= i
    return prod

def list_factorial(x):
    """Compute the factorial of numbers in a list"""
    results = []
    for n in x:
        results.append(fact(n))
    return results

if __name__ == '__main__':
    data = get_data(_len = 1000)
    list_factorial(data)
    
