"""
Test the factorial function
"""

import unittest
from factorial import fact, FactorialException

class FactorialTestCase(unittest.TestCase):

    def setUp(self):
        print "I'm in setup"

    def tearDown(self):
        print "here in tearDown"

    def test_factorial(self):
        print "test"
        factorial_cases = [(1, 1),
                           (5, 5*4*3*2*1),
                           (20, 2432902008176640000)]
        for n, fact_n in factorial_cases:
            self.assertEqual(fact_n, fact(n))

class FactorialArgumentsTestCase(unittest.TestCase):

    def test_larger_than_1(self):
        self.assertRaises(FactorialException, fact, -1)
        self.assertRaises(FactorialException, fact, 0)

if __name__ == '__main__':
    unittest.main()
