import random
from basic_agents import BasicAgent, BasicAgentFactory

class DrunkAgent(BasicAgent):
    def choose_action(self, game_state):
        self.say(random.choice(['Burp', 'Blah', 'Mrmmmf']))
        actions = game_state.getLegalActions(self.index)
        return random.choice(actions)
    
class DrunkAgentFactory(BasicAgentFactory):
    def get_agents_list(self):
        return [DrunkAgent, DrunkAgent]
