import random
from basic_agents import BasicAgent, BasicAgentFactory


max_path_length=40
def recursive_f(food, remaining_food_input, current_path_input):
    if not remaining_food_input:
        paths.append(current_path_input)
    else:
        current_path =list(current_path_input)
        remaining_food=list(remaining_food_input)
        
        for next_food in remaining_food: #sort this list by distance with food!
            t_path=get_path(food, next_food)
            if len(current_path)+len(t_path)<=max_path_length:
                
                for f_index in range(len(total_food)):
                    if total_food[f_index] == next_food:
                        remaining_foods.pop(f_index)
                current_path.append(t_path)
                recursive_f(next_food, remaining_food, current_path)
            else:
                remaining_food=[]
                paths.append(current_path) #not sure!!

def which_food(path):
    foods=[]
    if self.is_red:
        food_map=game_state.getRedFood()
    else:  
        food_map=game_state.getBlueFood()
        
    total_food=[]
    for x in food_map:
        for y in food_map[x]:
                if food_map[x][y]:
                    total_food.append([x,y])
   
    for pos in path:
        if pos in total_food:
            foods.append(pos)
    return foods
class EatAgent(BasicAgent):
    
    
    def possible_paths(self, game_state):
        agent_index=self.index
        position=game_state.getAgentPosition(agent_index)
        if self.is_red:
            food_map=game_state.getRedFood()
        else:  
            food_map=game_state.getBlueFood()
        total_food=[]
        for x in food_map:
            for y in food_map[x]:
                    if food_map[x][y]:
                        total_food.append([x,y])

        paths=[]
        remaining_foods=list(total_food)
        current_path=[]
        recursive_f(position, remaining_foods, current_path )
        def cmp_function(x, y):
            if len(which_food(x))>len(which_food(y)):
                return 1
            elif len(which_food(x))<len(which_food(y)):
                return -1
            else:
                return 0
           
        paths.sort(cmp_function)
        print paths
        return paths
            
    def choose_action(self, game_state):
        self.say(str(self.index))
        actions = game_state.getLegalActions(self.index)
        return random.choice(actions)
    
    def register_initial_state(self, game_state):
        super(EatAgent, self).register_initial_state(game_state)
        maze=game_state.getWalls()
        print self.is_red
        
class EatAgentFactory(BasicAgentFactory):
    def get_agents_list(self):
        return [EatAgent, EatAgent]
    
    
def possible_paths(position, foo):
    pass
