import os
from types import ListType
from pickle import dump
import numpy
import random

class AgentTournament(object):
    
    def __init__(self):
        self.agents=['GerdLorenzoAgentFactory']
        self.mazes=['alleyCapture','contest09Capture','contest19Capture','bloxCapture','contest10Capture','contest20Capture','contest01Capture','contest11Capture','crowdedCapture','contest02Capture','contest12Capture','defaultCapture','contest03Capture','contest13Capture','fastCapture','contest04Capture','contest14Capture','jumboCapture','contest05Capture','contest15Capture','mediumCapture','contest06Capture','contest16Capture','officeCapture','contest07Capture','contest17Capture','randomCapture','contest08Capture','contest18Capture','tinyCapture']        
        #self.mazes=['contest01Capture','contest02Capture','contest03Capture']
    
    
    def fight(self, agentpair, opponents, maze):
        os.system('python capture.py --fps=1000 -b '+agentpair+' -r '+opponents+' -l '+maze)

    def get_agent_fitness(self, agentpair, opponents, mazes):
        """" let a agent fight in all mazes against all opponents and return as fitness the overall gamescores"""
        fitness=0
        #dummy = []
        #dummy.append(mazes)
     
        for m in mazes:
            self.fight(agentpair, opponents, m)
            print 'next'
            raw_input()
            f = open('/home/student/score.dat','r')
            out=float(f.read())
            fitness +=out
            f.close()
        return fitness    
    
    def create_weighted_agent(self, weights):
        f=open('weights','w')
        dump(weights,f)
        f.close()
    
    def tournament(self):
        for i in range(10):
            weights=numpy.random.uniform(0,1,8)
            self.create_weighted_agent(weights)
            fitness = self.get_agent_fitness('JansAgentFactory','GerdLorenzoAgentFactory',[random.choice(self.mazes),random.choice(self.mazes),random.choice(self.mazes)])
            print 'agent'+str(weights)+'performed:'+str(fitness)
        
        
if __name__ == '__main__':
    
    print 'tournament started'
    test_tourn = AgentTournament()
    test_tourn.tournament()
    #print test_tourn.get_agent_fitness('JansAgentFactory',['JansAgentFactory','JansAgentFactory'],test_tourn.mazes[-1])
    #test_tourn.fight('TwoDistsAgentFactory', 'TwoDistsAgentFactory', test_tourn.mazes[1])
