import random
from basic_agents import BasicAgent, BasicAgentFactory

class Group2DrunkAgent(BasicAgent):
    def choose_action(self, game_state):
        self.say(random.choice(['Burp', 'Blah', 'Mrmmmf']))
        actions = game_state.getLegalActions(self.index)
        return random.choice(actions)
    
class Group2DrunkAgentFactory(BasicAgentFactory):
    def get_agents_list(self):
        return [Group2DrunkAgent,Group2DrunkAgent]
