"""
TO START:
python capture.py -r Group2AgentFactory_2


"""

from basic_agents import BasicAgent, BasicAgentFactory
from game import Directions
import unittest
import random
import paths
import networkx as nx
from Group2BasicAgent import Group2BasicAgent
from group2_3_Agents import Group2Agent_5
from anja_Agents import AnjaAgent

class Group2Agent_2(BasicAgent):
    def choose_action(self, game_state):
        self.say(random.choice(['Burp', 'Blah', 'Mrmmmf']))
        actions = game_state.getLegalActions(self.index)
        return random.choice(actions)
    
class Group2AgentFactory_2(BasicAgentFactory):
    def get_agents_list(self):
        return [FirstAgent_2, Group2Agent_5]
 # FirstAgent_2 is hunter 
 # Group2Agent_5 is eater with evasive actions
    
class FirstAgent_2(Group2BasicAgent):
#    def register_initial_state(self, game_state):
#        """This method handles the initial setup of the agent.
#        You should override it if you have any business to do
#        before the game begins (e.g., analyzing the maze).
#        Make sure to invoke the super method when you override this.
#        """
            
    def register_initial_state(self, game_state):
        super(FirstAgent_2, self).register_initial_state(game_state)
        self.state = 'go_to'
        
        #self.target_pos = self.findRandomSpot()
        #self.target_pos = (5,1)
        self.target_pos  = random.choice(self.where_our_food_is(game_state)) 
        
        self.opponent_pos = (None,None)
        print 'I ll go to',self.target_pos
        
    
    def where_our_food_is(self, game_state):
        if self.is_red:
            food_nodes = game_state.getRedFood().asList()
        else:
            food_nodes = game_state.getBlueFood().asList()       
        return food_nodes
        
        
    def choose_action(self, game_state, radarRange=7):
        self.say(random.choice(['Go WEST', 'NANANANA']))
        self.my_pos = game_state.getAgentPosition(self.index)
        
        # 1. Send it to a specific position
        if self.state == "go_to":
            
            if self.target_pos == self.my_pos:
                print "I will patrol"
                self.state = 'patrol'
                self.say('patrol.......')
            else:
                return paths.action_to_reach(self.maze_graph, \
                self.my_pos, self.target_pos)
        
        # 2 Patrol and detect
        if self.state == 'patrol':
#            print "%s, ,%s, , %s" % (','.join(map(str,game_state.getAgentDistances())), ','.join(map(str,self.get_team_distances(game_state))),','.join(map(str,self.get_team_positions(game_state))))
            enemies = self.get_team_positions(game_state)
        
            for opponent in enemies:
                if  opponent != None:
                    print "spotted enemy at", opponent
                    # check if relevant to my_pos
                    same_camp = self.checkCamp(opponent)
                    if not same_camp:
                        print "but he was in the other side"
                        continue
                    if len(nx.shortest_path(self.maze_graph, self.my_pos, opponent)) > radarRange:
                        print nx.shortest_path(self.maze_graph, self.my_pos, opponent), len(nx.astar_path(self.maze_graph, self.my_pos, opponent))
                        print "he is too far away",len(nx.shortest_path(self.maze_graph, self.my_pos, opponent))
                        self.say('saw him, but no chance')
                        pass
#                        return paths.action_to_reach(self.maze_graph,self.my_pos,self.target_pos)
                    else:
                        print 'I will attack now'
                        self.opponent_pos = opponent
                        self.say('ATTACK!!!!!!!!!!')
                        return paths.action_to_reach(self.maze_graph, \
                        self.my_pos, self.opponent_pos)
                # self.target_pos  = random.choice(self.where_our_food_is(game_state))
                our_food = self.where_our_food_is(game_state)
                if self.target_pos not in our_food:
                    self.target_pos = random.choice(our_food)
                if self.my_pos == self.target_pos:
                    self.target_pos = random.choice(our_food)      
                if random.random() > 0.5:
                    self.target_pos = random.choice(self.maze_graph.neighbors(self.my_pos))
                print 'i am and i go', self.my_pos, self.target_pos
                return paths.action_to_reach(self.maze_graph, \
                    self.my_pos, self.target_pos)
            return paths.action_to_reach(self.maze_graph, \
                    self.my_pos, self.opponent_pos)
            
        
    def checkCamp(self, opponent):
        if abs(self.my_pos[0] - opponent[0]) < 7:
            return True
        else:
            return False 
       
        
        
    def findRandomSpot(self):
        _middle = (self.my_maze.width/2)
        for node in self.maze_graph:
            if (self.is_red) & (node[1] > _middle):
                pass
            elif not (self.is_red) & (node[1] < _middle):     
                pass
            else:
                target_pos = node
                 
        return target_pos

       
